<id>
Last.fm Statistics for YaBB 2.3/2.3.1
</id>

<version>
1.1
</version>

<mod info>
Allows members to display Last.fm widgets in their profile.

History
1.0 - First release by Derek Barnstorm - 31st January 2009 
1.1 - Fixed minor bug with info still showing if disabled and positioned options better in profile - 5th February 2009

Files to edit
AdminIndex.pl
Admin/AdminSubList.pl
Admin/ModList.pl  
Languages/English/Admin.lng
Sources/Display.pl 
Sources/Load.pl 
Sources/MyCenter.pl 
Sources/Profile.pl 
Sources/System.pl 
Templates/default/Display.template
Templates/yabb2/Display.template
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
$lastfm_mod = "lastfm|$mod_list{'lastfm'}|$mod_list{'lastfm1'}|";
push (@boardmod_mods, "$lastfm_mod");
</add before>

<edit file>
Admin/AdminSubList.pl 
</edit file>

<search for>
'ipban3',"Admin.pl&ipban_update",
</search for>

<add after>
'lastfm',"LastFMSettings.pl&LastFM",
'lastfm2',"LastFMSettings.pl&LastFM2",
</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$lastfm_mod = "Last.fm Statistics|Derek Barnstorm|Allows members to display Last.fm widgets in their profile|1.1|5th February 2009";
	push (@installed_mods, "$lastfm_mod");
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
);

%smtp_txt = (
</search for>

<add before>
'lastfm' => 'Last.fm Settings',
'lastfm1' => 'Edit Last.fm Settings',
</add before>

<edit file>
Sources/Display.pl
</edit file>

<search for>
&LoadLanguage('FA');
</search for>

<add after>
&LoadLanguage('LastFM');

</add after>

<search for>
if ($iamgmod) { require "$vardir/gmodsettings.txt"; }
</search for>

<add after>
if (-e("$vardir/LastFM.txt")) { require "$vardir/LastFM.txt"; }
</add after>

<search for>
		my ($star, $userlocation, $aimad, $yimad, $msnad, $gtalkad, $skypead, $icqad, $buddyad, $addbuddy, $isbuddy, $addbuddylink, $userOnline, $signature, $signature_hr, $sendm, $lastmodified);
</search for>

<add after>
        my ($lastfmad);
</add after>

<search for>
			$skypead = ${$uid.$musername}{'skype'} ? qq~$menusep${$uid.$musername}{'skype'}~ : '';
</search for>

<add after>
			$lastfmad = ${$uid.$musername}{'lastfm'} ? qq~$menusep${$uid.$musername}{'lastfm'}~ : '' if $en_lastfmstats;
</add after>

<search for>
		$contactblock =~ s/({|<)yabb skype(}|>)/$skypead/g;
</search for>

<add after>
		$contactblock =~ s/({|<)yabb lastfm(}|>)/$lastfmad/g;
</add after>

<edit file>
Sources/Load.pl
</edit file>

<search for>
require "$sourcedir/System.pl";
</search for>

<add after>
&LoadLanguage('LastFM');
</add after>

<search for>
		$skypeimg = qq~<img src="$imagesdir/skype.gif" alt="${$uid.$user}{'skype'}" title="${$uid.$user}{'skype'}" border="0" />~;
</search for>

<add after>
		$lastfmimg = qq~<img src="$modimgurl/LastFM/lastfm.gif" alt="${$uid.$user}{'lastfm'}" title="${$uid.$user}{'lastfm'}" border="0" />~;
</add after>

<search for>
		$skypeimg   = qq~<span class="imgwindowbg">Skype/VoIP</span>~;
</search for>

<add after>
		$lastfmimg   = qq~<span class="imgwindowbg">$lastfm_txt{'01'}</span>~;
</add after>

<search for>
		$skypeimg = qq~<img src="$yyhtml_root/Buttons/$language/skype.png" alt="${$uid.$user}{'skype'}" title="${$uid.$user}{'skype'}" border="0" />~;
</search for>

<add after>
		$lastfmimg = qq~<img src="$modimgurl/LastFM/lastfm.png" alt="${$uid.$user}{'lastfm'}" title="${$uid.$user}{'lastfm'}" border="0" />~;
</add after>

<search for>
	${$uid.$user}{'msn'}   = ${$uid.$user}{'msn'}   ? $msnimg : '';
</search for>

<add before>
	${$uid.$user}{'lastfm'} = ${$uid.$user}{'lastfm'} ? qq~<a href="http://www.last.fm/user/${$uid.$user}{'lastfm'}" target="_blank">$lastfmimg</a>~ : '';
</add before>

<edit file>
Sources/MyCenter.pl
</edit file>

<search for>
&LoadLanguage('MyCenter');
</search for>

<add after>
&LoadLanguage('LastFM');

</add after>

<search for>
if (-e "$vardir/gmodsettings.txt" && $iamgmod) { require "$vardir/gmodsettings.txt"; }
</search for>

<add after>
if (-e("$vardir/LastFM.txt")) { require "$vardir/LastFM.txt"; }
</add after>

<search for>
			$skypead = ${$uid.$usrname}{'skype'} ? qq~$menusep${$uid.$usrname}{'skype'}~ : '';
</search for>

<add after>
			$lastfmad = ${$uid.$usrname}{'lastfm'} ? qq~$menusep${$uid.$usrname}{'lastfm'}~ : '' if $en_lastfmstats;
</add after>

<search for>
			$membAdInfo = $profbutton . $wwwlink . $msnad . $gtalkad . $icqad . $yimad . $aimad . $skypead;
</search for>

<replace>
			$membAdInfo = $profbutton . $wwwlink . $lastfmad . $msnad . $gtalkad . $icqad . $yimad . $aimad . $skypead;
</replace>

<search for>
		my ($aimad, $yimad, $msnad, $gtalkad, $skypead, $icqad, $signature_hr);
</search for>

<add after>
		my ($lastfmad);
</add after>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
&LoadLanguage('Profile');
</search for>

<add after>
&LoadLanguage('LastFM');
</add after>

<search for>
if (-e "$vardir/gmodsettings.txt" && $iamgmod) { require "$vardir/gmodsettings.txt"; }
</search for>

<add before>
if (-e("$vardir/LastFM.txt")) { require "$vardir/LastFM.txt"; }
</add before>

<search for>
	&ToChars(${$uid.$user}{'webtitle'});
	$showProfile .= qq~<tr class="windowbg">
</search for>

<add before>

    ### Last.fm Statistics Start ###
	if (${$uid.$user}{'lastfmrecent'} == 1) { $lastfmrecentchk = ' checked="checked"'; }
    if (${$uid.$user}{'lastfmfriends'} == 1) { $lastfmfriendschk = ' checked="checked"'; }
    if (${$uid.$user}{'lastfmttracks'} == 1) { $lastfmttrackschk = ' checked="checked"'; }
    if (${$uid.$user}{'lastfmtartists'} == 1) { $lastfmtartistschk = ' checked="checked"'; }
    if (${$uid.$user}{'lastfmwttracks'} == 1) { $lastfmwttrackschk = ' checked="checked"'; }
    if (${$uid.$user}{'lastfmwtartists'} == 1) { $lastfmwtartistschk = ' checked="checked"'; }
    if (${$uid.$user}{'lastfmcolor'} eq 'red') { $lastfmred = ' selected="selected" '; }
    if (${$uid.$user}{'lastfmcolor'} eq 'blue') { $lastfmblue = ' selected="selected" '; }
    if (${$uid.$user}{'lastfmcolor'} eq 'black') { $lastfmblack = ' selected="selected" '; }
    if (${$uid.$user}{'lastfmcolor'} eq 'grey') { $lastfmgrey = ' selected="selected" '; }
    ### Last.fm Statistics End ###

</add before>

<search for>
	if ($extendedprofiles) {
		require "$sourcedir/ExtendedProfiles.pl";
		$showProfile .= &ext_editprofile($user,"contact");
	}
</search for>

<add after>
   ### Last.fm Statistics Start ###
   if ($en_lastfmstats) {
   $showProfile .= qq~
   <tr>
   <td colspan="2" class="catbg"><a href="http://www.last.fm" target="_blank"><img style="vertical-align: middle;" src="$modimgurl/LastFM/lastfm.gif" alt="$lastfm_txt{'01'}" title="$lastfm_txt{'01'}" border="0" /></a> <b>$lastfm_txt{'01'}</b></td>
   </tr><tr class="windowbg">
     <td width="320" align="left"><b>$lastfm_txt{'03'}: </b></td>
     <td align="left"><input type="text" maxlength="50" name="lastfm" size="40" value="${$uid.$user}{'lastfm'}" /></td>
   </tr>
   ~;
   }
   if ($en_lastfmstats && $en_lastfmrecent) {
   $showProfile .= qq~
   <tr class="windowbg">
     <td width="320" align="left"><b>$lastfm_txt{'04'} </b></td>
     <td align="left"><input type="checkbox" name="lastfmrecent" value="1"$lastfmrecentchk /></td>
   </tr>
   ~;
   }
   if ($en_lastfmstats && $en_lastfmrecent) {
   $showProfile .= qq~
   <tr class="windowbg">
     <td width="320" align="left"><b>$lastfm_txt{'05'} </b></td>
     <td align="left"><input type="checkbox" name="lastfmfriends" value="1"$lastfmfriendschk /></td>
   </tr>
   ~;
   }
   if ($en_lastfmstats && $en_lastfmttracks) {
   $showProfile .= qq~
   <tr class="windowbg">
     <td width="320" align="left"><b>$lastfm_txt{'06'} </b></td>
     <td align="left"><input type="checkbox" name="lastfmttracks" value="1"$lastfmttrackschk /></td>
   </tr>
   ~;
   }
      if ($en_lastfmstats && $en_lastfmtartists) {
   $showProfile .= qq~
   <tr class="windowbg">
     <td width="320" align="left"><b>$lastfm_txt{'07'} </b></td>
     <td align="left"><input type="checkbox" name="lastfmtartists" value="1"$lastfmtartistschk /></td>
   </tr>
      ~;
      }
      if ($en_lastfmstats && $en_lastfmwttracks) {
   $showProfile .= qq~
   <tr class="windowbg">
     <td width="320" align="left"><b>$lastfm_txt{'08'} </b></td>
     <td align="left"><input type="checkbox" name="lastfmwttracks" value="1"$lastfmwttrackschk /></td>
   </tr>
      ~;
      }
      if ($en_lastfmstats && $en_lastfmwtartists) {
   $showProfile .= qq~
   <tr class="windowbg">
     <td width="320" align="left"><b>$lastfm_txt{'09'} </b></td>
     <td align="left"><input type="checkbox" name="lastfmwtartists" value="1"$lastfmwtartistschk /></td>
   </tr>
      ~;
      }
      if ($en_lastfmstats && $en_lastfmcolor) {
   $showProfile .= qq~
   <tr class="windowbg">
     <td width="320" align="left"><b>$lastfm_txt{'10'}: </b></td>
     <td align="left">
     <select name="lastfmcolor" size="4">
     <option style="color: #d51007;" value="red"$lastfmred>$lastfm_txt{'red'}</option>
     <option style="color: #6598cd;" value="blue"$lastfmblue>$lastfm_txt{'blue'}</option>
     <option style="color: #000000;" value="black"$lastfmblack>$lastfm_txt{'black'}</option>
     <option style="color: #999999;" value="grey"$lastfmgrey>$lastfm_txt{'grey'}</option>
     </select>
    </td>
   </tr>
   ~;
   }
   ### Last.fm Statistics End ###
</add after>

<search for>
		&ToHTML($member{'skype'});
</search for>

<add after>
        ### Last.fm Statistics Start ###
		&ToHTML($member{'lastfm'});
		&ToHTML($member{'lastfmrecent'});
		&ToHTML($member{'lastfmfriends'});
		&ToHTML($member{'lastfmttracks'});
		&ToHTML($member{'lastfmtartists'});
		&ToHTML($member{'lastfmwttracks'});
		&ToHTML($member{'lastfmwtartists'});
		&ToHTML($member{'lastfmcolor'});
		### Last.fm Statistics End ###
</add after>

<search for>
		${$uid.$user}{'skype'} = $member{'skype'};
</search for>

<add after>
        ### Last.fm Statistics Start ###
		${$uid.$user}{'lastfm'} = $member{'lastfm'};
		${$uid.$user}{'lastfmrecent'} = $member{'lastfmrecent'};
		${$uid.$user}{'lastfmfriends'} = $member{'lastfmfriends'};
		${$uid.$user}{'lastfmttracks'} = $member{'lastfmttracks'};
		${$uid.$user}{'lastfmtartists'} = $member{'lastfmtartists'};
		${$uid.$user}{'lastfmwttracks'} = $member{'lastfmwttracks'};
		${$uid.$user}{'lastfmwtartists'} = $member{'lastfmwtartists'};
		${$uid.$user}{'lastfmcolor'} = $member{'lastfmcolor'};
		### Last.fm Statistics End ###
</add after>

<search for>
	my ($pic_row, $buddybutton, $row_addgrp, $row_gender, $row_age, $row_location, $row_icq, $row_aim, $row_yim, $row_msn, $row_gtalk, $row_skype, $row_email, $row_website, $row_signature, $showusertext);
</search for>

<add after>
	my ($row_lastfm, $row_lastfm2);
</add after>

<search for>
	if (${$uid.$user}{'hidemail'} ne 'checked' || $iamadmin || !$allow_hide_email || $view) {
</search for>

<add before>
    ### Last.fm Statistics Start ###
	if (${$uid.$user}{'lastfm'} && $en_lastfmstats) {
		$row_lastfm = qq~
		<div style="float: left; clear: left; width: 30%; padding-top: 5px;  padding-bottom: 5px;">
		<b>$lastfm_txt{'01'}: </b>
		</div>
		<div style="float: left; width: 70%; padding-top: 5px; padding-bottom: 5px;">
		<img src="$modimgurl/LastFM/lastfm.gif" alt="" border="0" style="vertical-align: middle;" />
		<a href="http://www.last.fm/user/${$uid.$user}{'lastfm'}" target="_blank">$lastfm_txt{'01'} ${$uid.$user}{'realname'}</a>
		</div>
	~;
	}
	### Last.fm Statistics End ###
</add before>

<search for>
		<a href="${$uid.$user}{'weburl'}" target="_blank">${$uid.$user}{'webtitle'}</a>
		</div>
		~;
	}
</search for>

<add after>
	### Last.fm Statistics Start ###
	if ($en_lastfmcolor && ${$uid.$user}{'lastfmcolor'} ne '') {
	$widgetcolor = "${$uid.$user}{'lastfmcolor'}";
	} else {
	$widgetcolor = "$lastfmadmincolor";
	}
    if (${$uid.$user}{'lastfmrecent'} && $en_lastfmrecent) {
        $recent = qq~
        <td valign="top">
        <style type="text/css">table.lfmWidgetchart_7fa039a00831568f0fd260990bb31635 td {margin:0 !important;padding:0 !important;border:0 !important;}table.lfmWidgetchart_7fa039a00831568f0fd260990bb31635 tr.lfmHead a:hover {background:url(http://cdn.last.fm/widgets/images/en/header/chart/recenttracks_regular_$widgetcolor.png) no-repeat 0 0 !important;}table.lfmWidgetchart_7fa039a00831568f0fd260990bb31635 tr.lfmEmbed object {float:left;}table.lfmWidgetchart_7fa039a00831568f0fd260990bb31635 tr.lfmFoot td.lfmConfig a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat 0px 0 !important;;}table.lfmWidgetchart_7fa039a00831568f0fd260990bb31635 tr.lfmFoot td.lfmView a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -85px 0 !important;}table.lfmWidgetchart_7fa039a00831568f0fd260990bb31635 tr.lfmFoot td.lfmPopup a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -159px 0 !important;}</style>
        <table class="lfmWidgetchart_7fa039a00831568f0fd260990bb31635" cellpadding="0" cellspacing="0" border="0" style="width:184px;"><tr class="lfmHead"><td><a title="${$uid.$user}{'lastfm'}: Recently Listened Tracks" href="http://www.last.fm/user/${$uid.$user}{'lastfm'}" target="_blank" style="display:block;overflow:hidden;height:20px;width:184px;background:url(http://cdn.last.fm/widgets/images/en/header/chart/recenttracks_regular_$widgetcolor.png) no-repeat 0 -20px;text-decoration:none;border:0;"></a></td></tr><tr class="lfmEmbed"><td><object type="application/x-shockwave-flash" data="http://cdn.last.fm/widgets/chart/19.swf" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" id="lfmEmbed_1916316274" width="184" height="179"> <param name="movie" value="http://cdn.last.fm/widgets/chart/19.swf" /> <param name="flashvars" value="type=recenttracks&amp;user=${$uid.$user}{'lastfm'}&amp;theme=$widgetcolor&amp;lang=en&amp;widget_id=chart_7fa039a00831568f0fd260990bb31635" /> <param name="allowScriptAccess" value="always" /> <param name="allowNetworking" value="all" /> <param name="allowFullScreen" value="true" /> <param name="quality" value="high" /> <param name="bgcolor" value="6598cd" /> <param name="wmode" value="transparent" /> <param name="menu" value="true" /> </object></td></tr><tr class="lfmFoot"><td style="background:url(http://cdn.last.fm/widgets/images/footer_bg/$widgetcolor.png) repeat-x 0 0;text-align:right;"><table cellspacing="0" cellpadding="0" border="0" style="width:184px;"><tr><td class="lfmConfig"><a href="http://www.last.fm/widgets/?colour=$widgetcolor&amp;chartType=recenttracks&amp;user=${$uid.$user}{'lastfm'}&amp;chartFriends=0&amp;from=code&amp;widget=chart" title="Get your own widget" target="_blank" style="display:block;overflow:hidden;width:85px;height:20px;float:right;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat 0px -20px;text-decoration:none;border:0;"></a></td><td class="lfmView" style="width:74px;"><a href="http://www.last.fm/user/${$uid.$user}{'lastfm'}" title="View ${$uid.$user}{'lastfm'}'s profile" target="_blank" style="display:block;overflow:hidden;width:74px;height:20px;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -85px -20px;text-decoration:none;border:0;"></a></td><td class="lfmPopup"style="width:25px;"><a href="http://www.last.fm/widgets/popup/?colour=$widgetcolor&amp;chartType=recenttracks&amp;user=${$uid.$user}{'lastfm'}&amp;chartFriends=0&amp;from=code&amp;widget=chart&amp;resize=1" title="Load this chart in a pop up" target="_blank" style="display:block;overflow:hidden;width:25px;height:20px;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -159px -20px;text-decoration:none;border:0;" onclick="window.open(this.href + '&amp;resize=0','lfm_popup','height=279,width=234,resizable=yes,scrollbars=yes'); return false;"></a></td></tr></table></td></tr></table>
        </td> 
        ~;
    }
    if (${$uid.$user}{'lastfmrecent'} && ${$uid.$user}{'lastfmfriends'} && $en_lastfmrecent) {
	    $recent = qq~ 
	    <td valign="top">
	    <style type="text/css">table.lfmWidgetchart_99fe4191783d87d5c27e26cbd45eef1c td {margin:0 !important;padding:0 !important;border:0 !important;}table.lfmWidgetchart_99fe4191783d87d5c27e26cbd45eef1c tr.lfmHead a:hover {background:url(http://cdn.last.fm/widgets/images/en/header/chart/recenttracks_regular_$widgetcolor.png) no-repeat 0 0 !important;}table.lfmWidgetchart_99fe4191783d87d5c27e26cbd45eef1c tr.lfmEmbed object {float:left;}table.lfmWidgetchart_99fe4191783d87d5c27e26cbd45eef1c tr.lfmFoot td.lfmConfig a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat 0px 0 !important;;}table.lfmWidgetchart_99fe4191783d87d5c27e26cbd45eef1c tr.lfmFoot td.lfmView a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -85px 0 !important;}table.lfmWidgetchart_99fe4191783d87d5c27e26cbd45eef1c tr.lfmFoot td.lfmPopup a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -159px 0 !important;}</style>
        <table class="lfmWidgetchart_99fe4191783d87d5c27e26cbd45eef1c" cellpadding="0" cellspacing="0" border="0" style="width:184px;"><tr class="lfmHead"><td><a title="${$uid.$user}{'lastfm'}: Recently Listened Tracks" href="http://www.last.fm/user/${$uid.$user}{'lastfm'}" target="_blank" style="display:block;overflow:hidden;height:20px;width:184px;background:url(http://cdn.last.fm/widgets/images/en/header/chart/recenttracks_regular_$widgetcolor.png) no-repeat 0 -20px;text-decoration:none;border:0;"></a></td></tr><tr class="lfmEmbed"><td><object type="application/x-shockwave-flash" data="http://cdn.last.fm/widgets/chart/friends_6.swf" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" id="lfmEmbed_1112844956" width="184" height="199"> <param name="movie" value="http://cdn.last.fm/widgets/chart/friends_6.swf" /> <param name="flashvars" value="type=recenttracks&amp;user=${$uid.$user}{'lastfm'}&amp;theme=$widgetcolor&amp;lang=en&amp;widget_id=chart_99fe4191783d87d5c27e26cbd45eef1c" /> <param name="allowScriptAccess" value="always" /> <param name="allowNetworking" value="all" /> <param name="allowFullScreen" value="true" /> <param name="quality" value="high" /> <param name="bgcolor" value="000000" /> <param name="wmode" value="transparent" /> <param name="menu" value="true" /> </object></td></tr><tr class="lfmFoot"><td style="background:url(http://cdn.last.fm/widgets/images/footer_bg/$widgetcolor.png) repeat-x 0 0;text-align:right;"><table cellspacing="0" cellpadding="0" border="0" style="width:184px;"><tr><td class="lfmConfig"><a href="http://www.last.fm/widgets/?colour=$widgetcolor&amp;chartType=recenttracks&amp;user=${$uid.$user}{'lastfm'}&amp;chartFriends=1&amp;from=code&amp;widget=chart" title="Get your own widget" target="_blank" style="display:block;overflow:hidden;width:85px;height:20px;float:right;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat 0px -20px;text-decoration:none;border:0;"></a></td><td class="lfmView" style="width:74px;"><a href="http://www.last.fm/user/${$uid.$user}{'lastfm'}" title="View ${$uid.$user}{'lastfm'}'s profile" target="_blank" style="display:block;overflow:hidden;width:74px;height:20px;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -85px -20px;text-decoration:none;border:0;"></a></td><td class="lfmPopup"style="width:25px;"><a href="http://www.last.fm/widgets/popup/?colour=$widgetcolor&amp;chartType=recenttracks&amp;user=${$uid.$user}{'lastfm'}&amp;chartFriends=1&amp;from=code&amp;widget=chart&amp;resize=1" title="Load this chart in a pop up" target="_blank" style="display:block;overflow:hidden;width:25px;height:20px;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -159px -20px;text-decoration:none;border:0;" onclick="window.open(this.href + '&amp;resize=0','lfm_popup','height=299,width=234,resizable=yes,scrollbars=yes'); return false;"></a></td></tr></table></td></tr></table> 
        </td> 
        ~;
    }
    if (${$uid.$user}{'lastfmttracks'} && $en_lastfmttracks) {
	    $ttracks = qq~
	    <td valign="top">
	    <style type="text/css">table.lfmWidgetchart_7b93ab7958915e28022508abb1bdba40 td {margin:0 !important;padding:0 !important;border:0 !important;}table.lfmWidgetchart_7b93ab7958915e28022508abb1bdba40 tr.lfmHead a:hover {background:url(http://cdn.last.fm/widgets/images/en/header/chart/toptracks_regular_$widgetcolor.png) no-repeat 0 0 !important;}table.lfmWidgetchart_7b93ab7958915e28022508abb1bdba40 tr.lfmEmbed object {float:left;}table.lfmWidgetchart_7b93ab7958915e28022508abb1bdba40 tr.lfmFoot td.lfmConfig a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat 0px 0 !important;;}table.lfmWidgetchart_7b93ab7958915e28022508abb1bdba40 tr.lfmFoot td.lfmView a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -85px 0 !important;}table.lfmWidgetchart_7b93ab7958915e28022508abb1bdba40 tr.lfmFoot td.lfmPopup a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -159px 0 !important;}</style>
        <table class="lfmWidgetchart_7b93ab7958915e28022508abb1bdba40" cellpadding="0" cellspacing="0" border="0" style="width:184px;"><tr class="lfmHead"><td><a title="${$uid.$user}{'lastfm'}: Overall Top Tracks" href="http://www.last.fm/user/${$uid.$user}{'lastfm'}/charts?charttype=overall&subtype=track" target="_blank" style="display:block;overflow:hidden;height:20px;width:184px;background:url(http://cdn.last.fm/widgets/images/en/header/chart/toptracks_regular_$widgetcolor.png) no-repeat 0 -20px;text-decoration:none;border:0;"></a></td></tr><tr class="lfmEmbed"><td><object type="application/x-shockwave-flash" data="http://cdn.last.fm/widgets/chart/19.swf" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" id="lfmEmbed_1079375552" width="184" height="160"> <param name="movie" value="http://cdn.last.fm/widgets/chart/19.swf" /> <param name="flashvars" value="type=toptracks&amp;user=${$uid.$user}{'lastfm'}&amp;theme=$widgetcolor&amp;lang=en&amp;widget_id=chart_7b93ab7958915e28022508abb1bdba40" /> <param name="allowScriptAccess" value="always" /> <param name="allowNetworking" value="all" /> <param name="allowFullScreen" value="true" /> <param name="quality" value="high" /> <param name="bgcolor" value="000000" /> <param name="wmode" value="transparent" /> <param name="menu" value="true" /> </object></td></tr><tr class="lfmFoot"><td style="background:url(http://cdn.last.fm/widgets/images/footer_bg/$widgetcolor.png) repeat-x 0 0;text-align:right;"><table cellspacing="0" cellpadding="0" border="0" style="width:184px;"><tr><td class="lfmConfig"><a href="http://www.last.fm/widgets/?colour=$widgetcolor&amp;chartType=toptracks&amp;user=${$uid.$user}{'lastfm'}&amp;chartFriends=1&amp;from=code&amp;widget=chart" title="Get your own widget" target="_blank" style="display:block;overflow:hidden;width:85px;height:20px;float:right;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat 0px -20px;text-decoration:none;border:0;"></a></td><td class="lfmView" style="width:74px;"><a href="http://www.last.fm/user/${$uid.$user}{'lastfm'}" title="View ${$uid.$user}{'lastfm'}'s profile" target="_blank" style="display:block;overflow:hidden;width:74px;height:20px;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -85px -20px;text-decoration:none;border:0;"></a></td><td class="lfmPopup"style="width:25px;"><a href="http://www.last.fm/widgets/popup/?colour=$widgetcolor&amp;chartType=toptracks&amp;user=${$uid.$user}{'lastfm'}&amp;chartFriends=1&amp;from=code&amp;widget=chart&amp;resize=1" title="Load this chart in a pop up" target="_blank" style="display:block;overflow:hidden;width:25px;height:20px;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -159px -20px;text-decoration:none;border:0;" onclick="window.open(this.href + '&amp;resize=0','lfm_popup','height=260,width=234,resizable=yes,scrollbars=yes'); return false;"></a></td></tr></table></td></tr></table>
        </td> 
        ~;
    }
    if (${$uid.$user}{'lastfmtartists'} && $en_lastfmtartists) {
	    $tartists = qq~
	    <td valign="top">
	    <style type="text/css">table.lfmWidgetchart_8bec2f60c835cb975193ee4b7e6fcf32 td {margin:0 !important;padding:0 !important;border:0 !important;}table.lfmWidgetchart_8bec2f60c835cb975193ee4b7e6fcf32 tr.lfmHead a:hover {background:url(http://cdn.last.fm/widgets/images/en/header/chart/topartists_regular_$widgetcolor.png) no-repeat 0 0 !important;}table.lfmWidgetchart_8bec2f60c835cb975193ee4b7e6fcf32 tr.lfmEmbed object {float:left;}table.lfmWidgetchart_8bec2f60c835cb975193ee4b7e6fcf32 tr.lfmFoot td.lfmConfig a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat 0px 0 !important;;}table.lfmWidgetchart_8bec2f60c835cb975193ee4b7e6fcf32 tr.lfmFoot td.lfmView a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -85px 0 !important;}table.lfmWidgetchart_8bec2f60c835cb975193ee4b7e6fcf32 tr.lfmFoot td.lfmPopup a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -159px 0 !important;}</style>
        <table class="lfmWidgetchart_8bec2f60c835cb975193ee4b7e6fcf32" cellpadding="0" cellspacing="0" border="0" style="width:184px;"><tr class="lfmHead"><td><a title="${$uid.$user}{'lastfm'}: Overall Top Artists" href="http://www.last.fm/user/${$uid.$user}{'lastfm'}/charts?charttype=overall&subtype=artist" target="_blank" style="display:block;overflow:hidden;height:20px;width:184px;background:url(http://cdn.last.fm/widgets/images/en/header/chart/topartists_regular_$widgetcolor.png) no-repeat 0 -20px;text-decoration:none;border:0;"></a></td></tr><tr class="lfmEmbed"><td><object type="application/x-shockwave-flash" data="http://cdn.last.fm/widgets/chart/19.swf" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" id="lfmEmbed_27413069" width="184" height="140"> <param name="movie" value="http://cdn.last.fm/widgets/chart/19.swf" /> <param name="flashvars" value="type=topartists&amp;user=${$uid.$user}{'lastfm'}&amp;theme=$widgetcolor&amp;lang=en&amp;widget_id=chart_8bec2f60c835cb975193ee4b7e6fcf32" /> <param name="allowScriptAccess" value="always" /> <param name="allowNetworking" value="all" /> <param name="allowFullScreen" value="true" /> <param name="quality" value="high" /> <param name="bgcolor" value="000000" /> <param name="wmode" value="transparent" /> <param name="menu" value="true" /> </object></td></tr><tr class="lfmFoot"><td style="background:url(http://cdn.last.fm/widgets/images/footer_bg/$widgetcolor.png) repeat-x 0 0;text-align:right;"><table cellspacing="0" cellpadding="0" border="0" style="width:184px;"><tr><td class="lfmConfig"><a href="http://www.last.fm/widgets/?colour=$widgetcolor&amp;chartType=topartists&amp;user=${$uid.$user}{'lastfm'}&amp;chartFriends=1&amp;from=code&amp;widget=chart" title="Get your own widget" target="_blank" style="display:block;overflow:hidden;width:85px;height:20px;float:right;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat 0px -20px;text-decoration:none;border:0;"></a></td><td class="lfmView" style="width:74px;"><a href="http://www.last.fm/user/${$uid.$user}{'lastfm'}" title="View ${$uid.$user}{'lastfm'}'s profile" target="_blank" style="display:block;overflow:hidden;width:74px;height:20px;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -85px -20px;text-decoration:none;border:0;"></a></td><td class="lfmPopup"style="width:25px;"><a href="http://www.last.fm/widgets/popup/?colour=$widgetcolor&amp;chartType=topartists&amp;user=${$uid.$user}{'lastfm'}&amp;chartFriends=1&amp;from=code&amp;widget=chart&amp;resize=1" title="Load this chart in a pop up" target="_blank" style="display:block;overflow:hidden;width:25px;height:20px;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -159px -20px;text-decoration:none;border:0;" onclick="window.open(this.href + '&amp;resize=0','lfm_popup','height=240,width=234,resizable=yes,scrollbars=yes'); return false;"></a></td></tr></table></td></tr></table>
        </td>
        ~;
    }
    if (${$uid.$user}{'lastfmwttracks'} && $en_lastfmwttracks) {
		$wttracks = qq~ 
		<td valign="top">
        <style type="text/css">table.lfmWidgetchart_781f761db3639e2e20aa97ddd3b00278 td {margin:0 !important;padding:0 !important;border:0 !important;}table.lfmWidgetchart_781f761db3639e2e20aa97ddd3b00278 tr.lfmHead a:hover {background:url(http://cdn.last.fm/widgets/images/en/header/chart/weeklytracks_regular_$widgetcolor.png) no-repeat 0 0 !important;}table.lfmWidgetchart_781f761db3639e2e20aa97ddd3b00278 tr.lfmEmbed object {float:left;}table.lfmWidgetchart_781f761db3639e2e20aa97ddd3b00278 tr.lfmFoot td.lfmConfig a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat 0px 0 !important;;}table.lfmWidgetchart_781f761db3639e2e20aa97ddd3b00278 tr.lfmFoot td.lfmView a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -85px 0 !important;}table.lfmWidgetchart_781f761db3639e2e20aa97ddd3b00278 tr.lfmFoot td.lfmPopup a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -159px 0 !important;}</style>
        <table class="lfmWidgetchart_781f761db3639e2e20aa97ddd3b00278" cellpadding="0" cellspacing="0" border="0" style="width:184px;"><tr class="lfmHead"><td><a title="${$uid.$user}{'lastfm'}: Weekly Top Tracks" href="http://www.last.fm/user/${$uid.$user}{'lastfm'}/charts?charttype=weekly&subtype=track" target="_blank" style="display:block;overflow:hidden;height:20px;width:184px;background:url(http://cdn.last.fm/widgets/images/en/header/chart/weeklytracks_regular_$widgetcolor.png) no-repeat 0 -20px;text-decoration:none;border:0;"></a></td></tr><tr class="lfmEmbed"><td><object type="application/x-shockwave-flash" data="http://cdn.last.fm/widgets/chart/19.swf" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" id="lfmEmbed_592354829" width="184" height="160"> <param name="movie" value="http://cdn.last.fm/widgets/chart/19.swf" /> <param name="flashvars" value="type=weeklytrackchart&amp;user=${$uid.$user}{'lastfm'}&amp;theme=$widgetcolor&amp;lang=en&amp;widget_id=chart_781f761db3639e2e20aa97ddd3b00278" /> <param name="allowScriptAccess" value="always" /> <param name="allowNetworking" value="all" /> <param name="allowFullScreen" value="true" /> <param name="quality" value="high" /> <param name="bgcolor" value="000000" /> <param name="wmode" value="transparent" /> <param name="menu" value="true" /> </object></td></tr><tr class="lfmFoot"><td style="background:url(http://cdn.last.fm/widgets/images/footer_bg/$widgetcolor.png) repeat-x 0 0;text-align:right;"><table cellspacing="0" cellpadding="0" border="0" style="width:184px;"><tr><td class="lfmConfig"><a href="http://www.last.fm/widgets/?colour=$widgetcolor&amp;chartType=weeklytracks&amp;user=${$uid.$user}{'lastfm'}&amp;chartFriends=1&amp;from=code&amp;widget=chart" title="Get your own widget" target="_blank" style="display:block;overflow:hidden;width:85px;height:20px;float:right;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat 0px -20px;text-decoration:none;border:0;"></a></td><td class="lfmView" style="width:74px;"><a href="http://www.last.fm/user/${$uid.$user}{'lastfm'}" title="View ${$uid.$user}{'lastfm'}'s profile" target="_blank" style="display:block;overflow:hidden;width:74px;height:20px;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -85px -20px;text-decoration:none;border:0;"></a></td><td class="lfmPopup"style="width:25px;"><a href="http://www.last.fm/widgets/popup/?colour=$widgetcolor&amp;chartType=weeklytracks&amp;user=${$uid.$user}{'lastfm'}&amp;chartFriends=1&amp;from=code&amp;widget=chart&amp;resize=1" title="Load this chart in a pop up" target="_blank" style="display:block;overflow:hidden;width:25px;height:20px;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -159px -20px;text-decoration:none;border:0;" onclick="window.open(this.href + '&amp;resize=0','lfm_popup','height=260,width=234,resizable=yes,scrollbars=yes'); return false;"></a></td></tr></table></td></tr></table>
        </td> 
        ~;
    }
    if (${$uid.$user}{'lastfmwtartists'} && $en_lastfmwtartists) {
	    $wtartists = qq~ 
	    <td valign="top">
        <style type="text/css">table.lfmWidgetchart_0b97dc914aa6f6e1659741ade7d61da1 td {margin:0 !important;padding:0 !important;border:0 !important;}table.lfmWidgetchart_0b97dc914aa6f6e1659741ade7d61da1 tr.lfmHead a:hover {background:url(http://cdn.last.fm/widgets/images/en/header/chart/weeklyartists_regular_$widgetcolor.png) no-repeat 0 0 !important;}table.lfmWidgetchart_0b97dc914aa6f6e1659741ade7d61da1 tr.lfmEmbed object {float:left;}table.lfmWidgetchart_0b97dc914aa6f6e1659741ade7d61da1 tr.lfmFoot td.lfmConfig a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat 0px 0 !important;;}table.lfmWidgetchart_0b97dc914aa6f6e1659741ade7d61da1 tr.lfmFoot td.lfmView a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -85px 0 !important;}table.lfmWidgetchart_0b97dc914aa6f6e1659741ade7d61da1 tr.lfmFoot td.lfmPopup a:hover {background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -159px 0 !important;}</style>
        <table class="lfmWidgetchart_0b97dc914aa6f6e1659741ade7d61da1" cellpadding="0" cellspacing="0" border="0" style="width:184px;"><tr class="lfmHead"><td><a title="${$uid.$user}{'lastfm'}: Weekly Top Artists" href="http://www.last.fm/user/${$uid.$user}{'lastfm'}/charts?charttype=weekly&subtype=artist" target="_blank" style="display:block;overflow:hidden;height:20px;width:184px;background:url(http://cdn.last.fm/widgets/images/en/header/chart/weeklyartists_regular_$widgetcolor.png) no-repeat 0 -20px;text-decoration:none;border:0;"></a></td></tr><tr class="lfmEmbed"><td><object type="application/x-shockwave-flash" data="http://cdn.last.fm/widgets/chart/19.swf" codebase="http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=7,0,0,0" id="lfmEmbed_505504790" width="184" height="140"> <param name="movie" value="http://cdn.last.fm/widgets/chart/19.swf" /> <param name="flashvars" value="type=weeklyartistchart&amp;user=${$uid.$user}{'lastfm'}&amp;theme=$widgetcolor&amp;lang=en&amp;widget_id=chart_0b97dc914aa6f6e1659741ade7d61da1" /> <param name="allowScriptAccess" value="always" /> <param name="allowNetworking" value="all" /> <param name="allowFullScreen" value="true" /> <param name="quality" value="high" /> <param name="bgcolor" value="000000" /> <param name="wmode" value="transparent" /> <param name="menu" value="true" /> </object></td></tr><tr class="lfmFoot"><td style="background:url(http://cdn.last.fm/widgets/images/footer_bg/$widgetcolor.png) repeat-x 0 0;text-align:right;"><table cellspacing="0" cellpadding="0" border="0" style="width:184px;"><tr><td class="lfmConfig"><a href="http://www.last.fm/widgets/?colour=$widgetcolor&amp;chartType=weeklyartists&amp;user=${$uid.$user}{'lastfm'}&amp;chartFriends=1&amp;from=code&amp;widget=chart" title="Get your own widget" target="_blank" style="display:block;overflow:hidden;width:85px;height:20px;float:right;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat 0px -20px;text-decoration:none;border:0;"></a></td><td class="lfmView" style="width:74px;"><a href="http://www.last.fm/user/${$uid.$user}{'lastfm'}" title="View ${$uid.$user}{'lastfm'}'s profile" target="_blank" style="display:block;overflow:hidden;width:74px;height:20px;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -85px -20px;text-decoration:none;border:0;"></a></td><td class="lfmPopup"style="width:25px;"><a href="http://www.last.fm/widgets/popup/?colour=$widgetcolor&amp;chartType=weeklyartists&amp;user=${$uid.$user}{'lastfm'}&amp;chartFriends=1&amp;from=code&amp;widget=chart&amp;resize=1" title="Load this chart in a pop up" target="_blank" style="display:block;overflow:hidden;width:25px;height:20px;background:url(http://cdn.last.fm/widgets/images/en/footer/$widgetcolor.png) no-repeat -159px -20px;text-decoration:none;border:0;" onclick="window.open(this.href + '&amp;resize=0','lfm_popup','height=240,width=234,resizable=yes,scrollbars=yes'); return false;"></a></td></tr></table></td></tr></table>
        </td> 
        ~;
    }
	if (${$uid.$user}{'lastfm'} && $en_lastfmstats && (${$uid.$user}{'lastfmrecent'} || ${$uid.$user}{'lastfmttracks'} || ${$uid.$user}{'lastfmtartists'} || ${$uid.$user}{'lastfmwttracks'} || ${$uid.$user}{'lastfmwtartists'})) {
	  $row_lastfm2 = qq~
	  <tr>
		<td class="catbg" align="left">
		<a href="http://www.last.fm" target="_blank"><img src="$modimgurl/LastFM/lastfm.gif" alt="" border="0" style="vertical-align: middle;" /></a>&nbsp;
		<span class="text1"><b>$lastfm_txt{'02'}</b></span>
		</td>
		</tr>
		<tr>
		<td align="center" class="windowbg2">
		<table align="center">
		<tr>
          $recent
		  $ttracks
          $tartists
          $wttracks
          $wtartists
		</tr>
		</table>
	  </td>
	 </tr>
	~;
	}
	### Last.fm Statistics End ###
</add after>

<search for>
			$row_skype
</search for>

<add after>
			$row_lastfm
</add after>

<search for>
			$row_icq
		</td>
	</tr>
</search for>

<add after>
    $row_lastfm2
</add after>

<edit file>
Sources/System.pl
</edit file>

<search for>
	my @tags = qw(password realname email regdate regreason webtitle weburl spamcount spamtime signature postcount position addgroups icq aim yim skype gender usertext userpic regtime location bday timeselect timeoffset timeformat hidemail msn gtalk template language lastonline lastpost lastim im_ignorelist im_popup im_imspop notify_me board_notifications thread_notifications cathide postlayout session sesquest sesanswer favorites dsttimeoffset pageindex lastips onlinealert pmactprev pmmessprev pmviewMess buddylist offlinestatus awaysubj awayreply awayreplysent stealth reversetopic);
</search for>

<add after>
	push (@tags, "lastfm", "lastfmrecent", "lastfmfriends", "lastfmttracks", "lastfmtartists", "lastfmwttracks", "lastfmwtartists", "lastfmcolor");
</add after>

<edit file>
Templates/default/Display.template
</edit file>

<search for>
$contactlist = qq~
	{yabb email}{yabb profile}{yabb pm}{yabb www}{yabb msn}{yabb gtalk}{yabb skype}{yabb icq}{yabb yim}{yabb aim}{yabb addbuddy}
~;
</search for>

<replace>
$contactlist = qq~
	{yabb email}{yabb profile}{yabb pm}{yabb www}{yabb lastfm}{yabb msn}{yabb gtalk}{yabb skype}{yabb icq}{yabb yim}{yabb aim}{yabb addbuddy}
~;
</replace>

<edit file>
Templates/yabb21/Display.template
</edit file>

<search for>
$contactlist = qq~
	<yabb email><yabb profile><yabb pm><yabb www><yabb msn><yabb gtalk><yabb skype><yabb icq><yabb yim><yabb aim><yabb addbuddy>
~;
</search for>

<replace>
$contactlist = qq~
	<yabb email><yabb profile><yabb pm><yabb www><yabb lastfm><yabb msn><yabb gtalk><yabb skype><yabb icq><yabb yim><yabb aim><yabb addbuddy>
~;
</replace>
