###############################################################################
# LastFMSettings.pl                                                           #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.3.1                                                  #
# Packaged:       January 04, 2009                                            #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2009 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
###############################################################################

$lastfmadminplver = 'YaBB 2.3.1 $Revision: 1.0 $';
if($action eq 'detailedversion') { return 1; }
if (!-e("$vardir/LastFM.txt")) { &LastFM2; }
require "$vardir/LastFM.txt";
&LoadLanguage('LastFM');

sub LastFM { 
	
	&is_admin_or_gmod;
	
	if ($en_lastfmstats) { $chklastfmstats = 'checked="checked" '; }
	if ($en_lastfmrecent) { $chklastfmrecent = 'checked="checked" '; }
	if ($en_lastfmttracks) { $chklastfmttracks = 'checked="checked" '; }
	if ($en_lastfmtartists) { $chklastfmtartists = 'checked="checked" '; }
	if ($en_lastfmwttracks) { $chklastfmwttracks = 'checked="checked" '; }
	if ($en_lastfmwtartists) { $chklastfmwtartists = 'checked="checked" '; }
	if ($lastfmadmincolor eq 'red') { $sellastfmred = ' selected="selected" '; }
	if ($lastfmadmincolor eq 'blue') { $sellastfmblue = ' selected="selected" '; }
	if ($lastfmadmincolor eq 'black') { $sellastfmblack = ' selected="selected" '; }
	if ($lastfmadmincolor eq 'grey') { $sellastfmgrey = ' selected="selected" '; }
    if ($en_lastfmcolor) { $chklastfmcolor = 'checked="checked" '; }

$yymain .= qq~
<div class="bordercolor" style="padding: 0px; width: 99%; margin-left: 0px; margin-right: auto;">
	<form action="$adminurl?action=lastfm2" method="post">
	<table width="100%" cellspacing="1" cellpadding="4">
     <colgroup>
			<col width="50%" />
			<col width="50%" />
     </colgroup>
     <tr valign="middle">
       <td align="left" class="titlebg" colspan="2"><a href="http://www.last.fm" target="_blank"><img src="$modimgurl/LastFM/lastfm.gif" alt="$lastfm_txt{'01'}" title="$lastfm_txt{'01'}" border="0" /></a><b>$lastfmadmin_txt{'11'}</b></td>
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">$lastfmadmin_txt{'01'}</td>
       <td align="left" class="windowbg2"><input type="checkbox" name="en_lastfmstats" value="1" $chklastfmstats /></td>   
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">$lastfmadmin_txt{'02'}</td>
       <td align="left" class="windowbg2"><input type="checkbox" name="en_lastfmrecent" value="1" $chklastfmrecent /></td>   
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">$lastfmadmin_txt{'03'}</td>
       <td align="left" class="windowbg2"><input type="checkbox" name="en_lastfmttracks" value="1" $chklastfmttracks /></td>   
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">$lastfmadmin_txt{'04'}</td>
       <td align="left" class="windowbg2"><input type="checkbox" name="en_lastfmtartists" value="1" $chklastfmtartists /></td>   
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">$lastfmadmin_txt{'05'}</td>
       <td align="left" class="windowbg2"><input type="checkbox" name="en_lastfmwttracks" value="1" $chklastfmwttracks /></td>   
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">$lastfmadmin_txt{'06'}</td>
       <td align="left" class="windowbg2"><input type="checkbox" name="en_lastfmwtartists" value="1" $chklastfmwtartists /></td>   
     </tr>
     <tr valign="middle">
       <td align="left" class="windowbg2">$lastfmadmin_txt{'07'}</td>
       <td align="left" class="windowbg2">
       <select name="lastfmadmincolor" size="4">
       <option style="color: #d51007;" value="red"$sellastfmred>$lastfm_txt{'red'}</option>
       <option style="color: #6598cd;" value="blue"$sellastfmblue>$lastfm_txt{'blue'}</option>
       <option style="color: #000000;" value="black"$sellastfmblack>$lastfm_txt{'black'}</option>
       <option style="color: #999999;" value="grey"$sellastfmgrey>$lastfm_txt{'grey'}</option>
       </select>
       </td>   
     </tr> 
     <tr valign="middle">
       <td align="left" class="windowbg2">$lastfmadmin_txt{'08'}</td>
       <td align="left" class="windowbg2"><input type="checkbox" name="en_lastfmcolor" value="1" $chklastfmcolor /></td>   
     </tr>
     <tr valign="middle">
     <td align="center" class="catbg" colspan="2"><input type="submit" value="$lastfmadmin_txt{'09'}" /></td>
     </tr>
   </table>
   </form>
 </div>
~;

	$yytitle = $lastfmadmin_txt{'10'};
	$action_area = "lastfm";
	&AdminTemplate;
	exit;

}

sub LastFM2 {
	
	&is_admin_or_gmod;
	
	$en_lastfmstats = $FORM{'en_lastfmstats'} || "0";
	$en_lastfmrecent = $FORM{'en_lastfmrecent'} || "0";
    $en_lastfmttracks = $FORM{'en_lastfmttracks'} || "0";
    $en_lastfmtartists = $FORM{'en_lastfmtartists'} || "0";
	$en_lastfmwttracks = $FORM{'en_lastfmwttracks'} || "0";
    $en_lastfmwtartists = $FORM{'en_lastfmwtartists'} || "0";
    $lastfmadmincolor = $FORM{'lastfmadmincolor'} || "red";
    $en_lastfmcolor = $FORM{'en_lastfmcolor'} || "0";

    my $setfile = << "EOF";
###############################################################################
# LastFM.txt (Last.fm Statistics configurations)                              #
###############################################################################

\$en_lastfmstats = "$en_lastfmstats";
\$en_lastfmrecent = "$en_lastfmrecent";
\$en_lastfmttracks = "$en_lastfmttracks";
\$en_lastfmtartists = "$en_lastfmtartists";
\$en_lastfmwttracks = "$en_lastfmwttracks";
\$en_lastfmwtartists = "$en_lastfmwtartists";
\$lastfmadmincolor = "$lastfmadmincolor";
\$en_lastfmcolor = "$en_lastfmcolor";

1;
EOF

	fopen(FILE, ">$vardir/LastFM.txt");
	print FILE $setfile;
	fclose(FILE);

	if ($action eq "lastfm2") {
		$yySetLocation = qq~$adminurl?action=lastfm~;
		&redirectexit;
	}

}

1;